#include "init.h"

void RiadiacaKrivka(float t,float *bod);

void RotacnaPlocha_Vyhladena(int delenie_dlzky,int delenie_uhla)
{
/*
uhol	t0=				smerovy vektor	t1=				smerovy vektor	t2=
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

0		bod0[0][]	->	norm0[0][]		bod1[0][]	->	norm1[0][]		bod2[0][]
1		bod0[1][]	->	norm0[1][]		bod1[1][]	->	norm1[1][]		bod2[1][]
2		bod0[2][]	->	norm0[2][]		bod1[2][]	->	norm1[2][]		bod2[2][]
3		bod0[3][]	->	norm0[3][]		bod1[3][]	->	norm1[3][]		bod2[3][]
4		bod0[4][]	->	norm0[4][]		bod1[4][]	->	norm1[4][]		bod2[4][]
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

najprv	vypocitame vsetky body
potom	napr.: z bodov:				vypocitame normalovy vektor prislusneho stvorca
bod0[0][]				bod1[0][]				bod2[0][]
			norm0[0][]				norm1[0][]
bod0[1][]				bod1[1][]				bod2[1][]
			norm0[1][]				norm1[1][]
bod0[2][]				bod1[2][]				bod2[2][]
			norm0[2][]				norm1[2][]
bod0[3][]				bod1[3][]				bod2[3][]

a potom vypocitame vyhladene normalove vektory pre kazdy bod z pola bodov 0 a 1
norm0[0][]				norm1[0][]
			vnorm1[1][]			--	vyhladeny normalovy vektor pre bod1[1][] 
norm0[1][]				norm1[1][]

normalove vektory pre body bod[x][0][] vypocitame :
							norm0[0][]
				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
							norm0[1][]
*/
	float	(*bod0)[3];		// smernik na pole vrcholov, pricom vrchol ma 3 suradnice (je pole 3 suradnic)
	float	(*bod1)[3];
	float	(*bod2)[3];
	float	(*pomocny)[3];
	float	(*norm0)[3];			// normalovy vektor plochy
	float	(*norm1)[3];
	float	(*vnorm0)[3];			// vyhladeny normalovy vektor plochy
	float	(*vnorm1)[3];
	float	a[3],b[3],absolut;
	int		i,j=0;
	float	uhol;
	float	t0,t1,t2;
	float	krivka0[3],krivka1[3],krivka2[3];
	
	bod0  = new float[delenie_uhla][3];
	bod1  = new float[delenie_uhla][3];
	bod2  = new float[delenie_uhla][3];
	norm0 = new float[delenie_uhla][3];
	norm1 = new float[delenie_uhla][3];
	vnorm0= new float[delenie_uhla][3];
	vnorm1= new float[delenie_uhla][3];
	
	t0 = ( (float) j / (float) delenie_dlzky );
	RiadiacaKrivka(t0,krivka0);
	t1 = ( (float) (j+1) / (float) delenie_dlzky );
	RiadiacaKrivka(t1,krivka1);
	t2 = ( (float) (j+2) / (float) delenie_dlzky );
	RiadiacaKrivka(t2,krivka2);

	for(i=0;i<delenie_uhla;i++)
	{
		uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );

		bod0[i][0] = krivka0[0];
		bod0[i][1] = krivka0[1] * (float) cos( uhol ) - krivka0[2] * (float) sin( uhol );
		bod0[i][2] = krivka0[1] * (float) sin( uhol ) + krivka0[2] * (float) cos( uhol );

		bod1[i][0] = krivka1[0];
		bod1[i][1] = krivka1[1] * (float) cos( uhol ) - krivka1[2] * (float) sin( uhol );
		bod1[i][2] = krivka1[1] * (float) sin( uhol ) + krivka1[2] * (float) cos( uhol );
		
		bod2[i][0] = krivka2[0];
		bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
		bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
	}

	for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
	{
		if(i == (delenie_uhla-1) )
		{
			a[0] = bod1[0][0] - bod1[i][0];				//	+----->
			a[1] = bod1[0][1] - bod1[i][1];				//	 b    |
			a[2] = bod1[0][2] - bod1[i][2];				//	      |
		}												//	    a v
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod1[i][0] - bod0[i][0];
		b[1] = bod1[i][1] - bod0[i][1];
		b[2] = bod1[i][2] - bod0[i][2];
	
		norm0[i][0] = a[1]*b[2] - a[2]*b[1];
		norm0[i][1] = a[2]*b[0] - a[0]*b[2];
		norm0[i][2] = a[0]*b[1] - a[1]*b[0];
						//Optimalization vector
		absolut = (float) sqrt(norm0[i][0]*norm0[i][0]+norm0[i][1]*norm0[i][1]+norm0[i][2]*norm0[i][2]);
		if(absolut>0)		//avoid zero division error
		{
			norm0[i][0] = norm0[i][0]/absolut;
			norm0[i][1] = norm0[i][1]/absolut;
			norm0[i][2] = norm0[i][2]/absolut;
		}
	}

	for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
	{
		if(i == (delenie_uhla-1) )
		{
			a[0] = bod1[0][0] - bod1[i][0];		//	+----->
			a[1] = bod1[0][1] - bod1[i][1];		//	|     b
			a[2] = bod1[0][2] - bod1[i][2];		//	|
		}										//	V a
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod2[i][0] - bod1[i][0];
		b[1] = bod2[i][1] - bod1[i][1];
		b[2] = bod2[i][2] - bod1[i][2];
	
		norm1[i][0] = a[1]*b[2] - a[2]*b[1];
		norm1[i][1] = a[2]*b[0] - a[0]*b[2];
		norm1[i][2] = a[0]*b[1] - a[1]*b[0];
						//Optimalization vector
		absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
		if(absolut>0)		//avoid zero division error
		{
			norm1[i][0] = norm1[i][0]/absolut;
			norm1[i][1] = norm1[i][1]/absolut;
			norm1[i][2] = norm1[i][2]/absolut;
		}
	}
//	normalove vektory pre body bod[x][0][] vypocitame :
//							norm0[0][]
//				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
//							norm0[1][]
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm0[i][0]=( norm0[i-1][0] + norm0[i][0] )/2.0f;
		vnorm0[i][1]=( norm0[i-1][1] + norm0[i][1] )/2.0f;
		vnorm0[i][2]=( norm0[i-1][2] + norm0[i][2] )/2.0f;
	}
	vnorm0[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] )/2.0f;
	vnorm0[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] )/2.0f;
	vnorm0[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] )/2.0f;

//	norm0[0][]				norm1[0][]
//				vnorm1[1][]			--	vyhladeny normalovy vektor pre bod1[1][] 
//	norm0[1][]				norm1[1][]
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm1[i][0]=( norm0[i-1][0] + norm0[i][0] + norm1[i-1][0] + norm1[i][0] )/4.0f;
		vnorm1[i][1]=( norm0[i-1][1] + norm0[i][1] + norm1[i-1][1] + norm1[i][1] )/4.0f;
		vnorm1[i][2]=( norm0[i-1][2] + norm0[i][2] + norm1[i-1][2] + norm1[i][2] )/4.0f;
	}
	vnorm1[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] + norm1[delenie_uhla-1][0] + norm1[0][0] )/4.0f;
	vnorm1[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] + norm1[delenie_uhla-1][1] + norm1[0][1] )/4.0f;
	vnorm1[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] + norm1[delenie_uhla-1][2] + norm1[0][2] )/4.0f;

	glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)
	{
		glNormal3fv( vnorm0[i+1] );
		glVertex3fv(   bod0[i+1] );
		glNormal3fv( vnorm1[i+1] );
		glVertex3fv(   bod1[i+1] );
		glNormal3fv( vnorm1[i] );
		glVertex3fv(   bod1[i] );
		glNormal3fv( vnorm0[i] );
		glVertex3fv(   bod0[i] );
	}
	glNormal3fv( vnorm0[0] );
	glVertex3fv(   bod0[0] );
	glNormal3fv( vnorm1[0] );
	glVertex3fv(   bod1[0] );
	glNormal3fv( vnorm1[delenie_uhla-1] );
	glVertex3fv(   bod1[delenie_uhla-1] );
	glNormal3fv( vnorm0[delenie_uhla-1] );
	glVertex3fv(   bod0[delenie_uhla-1] );
	//glEnd();
	
	
	for(j=1;j<(delenie_dlzky-1);j++)
	{
		t2 = ( (float) (j+2) / (float) delenie_dlzky );
		RiadiacaKrivka(t2,krivka2);
	
		pomocny = bod0;
		bod0 = bod1;		// vymena poli vrcholov
		bod1 = bod2;
		bod2 = pomocny;
		for(i=0;i<delenie_uhla;i++)
		{
			uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );

			bod2[i][0] = krivka2[0];
			bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
			bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
		}
		pomocny = norm0;
		norm0 = norm1;
		norm1 = pomocny;
		for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
		{
			if(i == (delenie_uhla-1) )
			{
				a[0] = bod1[0][0] - bod1[i][0];
				a[1] = bod1[0][1] - bod1[i][1];
				a[2] = bod1[0][2] - bod1[i][2];
			}
			else
			{
				a[0] = bod1[i+1][0] - bod1[i][0];
				a[1] = bod1[i+1][1] - bod1[i][1];
				a[2] = bod1[i+1][2] - bod1[i][2];
			}
	
			b[0] = bod2[i][0] - bod1[i][0];
			b[1] = bod2[i][1] - bod1[i][1];
			b[2] = bod2[i][2] - bod1[i][2];
		
			norm1[i][0] = a[1]*b[2] - a[2]*b[1];
			norm1[i][1] = a[2]*b[0] - a[0]*b[2];
			norm1[i][2] = a[0]*b[1] - a[1]*b[0];
							//Optimalization vector
			absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
			if(absolut>0)		//avoid zero division error
			{
				norm1[i][0] = norm1[i][0]/absolut;
				norm1[i][1] = norm1[i][1]/absolut;
				norm1[i][2] = norm1[i][2]/absolut;
			}
		}
		
		pomocny = vnorm0;
		vnorm0 = vnorm1;
		vnorm1 = pomocny;
		for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
		{
			vnorm1[i][0]=( norm0[i-1][0] + norm0[i][0] + norm1[i-1][0] + norm1[i][0] )/4.0f;
			vnorm1[i][1]=( norm0[i-1][1] + norm0[i][1] + norm1[i-1][1] + norm1[i][1] )/4.0f;
			vnorm1[i][2]=( norm0[i-1][2] + norm0[i][2] + norm1[i-1][2] + norm1[i][2] )/4.0f;
		}
		vnorm1[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] + norm1[delenie_uhla-1][0] + norm1[0][0] )/4.0f;
		vnorm1[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] + norm1[delenie_uhla-1][1] + norm1[0][1] )/4.0f;
		vnorm1[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] + norm1[delenie_uhla-1][2] + norm1[0][2] )/4.0f;

		//glBegin(GL_QUADS);
		for(i=0;i<(delenie_uhla-1);i++)
		{
			glNormal3fv( vnorm0[i+1] );
			glVertex3fv(   bod0[i+1] );
			glNormal3fv( vnorm1[i+1] );
			glVertex3fv(   bod1[i+1] );
			glNormal3fv( vnorm1[i] );
			glVertex3fv(   bod1[i] );
			glNormal3fv( vnorm0[i] );
			glVertex3fv(   bod0[i] );
		}
		glNormal3fv( vnorm0[0] );
		glVertex3fv(   bod0[0] );
		glNormal3fv( vnorm1[0] );
		glVertex3fv(   bod1[0] );
		glNormal3fv( vnorm1[delenie_uhla-1] );
		glVertex3fv(   bod1[delenie_uhla-1] );
		glNormal3fv( vnorm0[delenie_uhla-1] );
		glVertex3fv(   bod0[delenie_uhla-1] );
		//glEnd();
	}

	//	normalove vektory pre body bod[x][0][] vypocitame :
	//	norm1[0][]
	//				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
	//	norm1[1][]
	pomocny = vnorm0;
	vnorm0 = vnorm1;
	vnorm1 = pomocny;
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm1[i][0]=( norm1[i-1][0] + norm1[i][0] )/2.0f;
		vnorm1[i][1]=( norm1[i-1][1] + norm1[i][1] )/2.0f;
		vnorm1[i][2]=( norm1[i-1][2] + norm1[i][2] )/2.0f;
	}
	vnorm1[0][0]=( norm1[delenie_uhla-1][0] + norm1[0][0] )/2.0f;
	vnorm1[0][1]=( norm1[delenie_uhla-1][1] + norm1[0][1] )/2.0f;
	vnorm1[0][2]=( norm1[delenie_uhla-1][2] + norm1[0][2] )/2.0f;

	//glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)
	{
		glNormal3fv( vnorm0[i+1] );
		glVertex3fv(   bod1[i+1] );
		glNormal3fv( vnorm1[i+1] );
		glVertex3fv(   bod2[i+1] );
		glNormal3fv( vnorm1[i] );
		glVertex3fv(   bod2[i] );
		glNormal3fv( vnorm0[i] );
		glVertex3fv(   bod1[i] );
	}
	glNormal3fv( vnorm0[0] );
	glVertex3fv(   bod1[0] );
	glNormal3fv( vnorm1[0] );
	glVertex3fv(   bod2[0] );
	glNormal3fv( vnorm1[delenie_uhla-1] );
	glVertex3fv(   bod2[delenie_uhla-1] );
	glNormal3fv( vnorm0[delenie_uhla-1] );
	glVertex3fv(   bod1[delenie_uhla-1] );
	glEnd();

	delete[] bod0;
	delete[] bod1;
	delete[] bod2;
	delete[] norm0;
	delete[] norm1;
	delete[] vnorm0;
	delete[] vnorm1;
}


void RotacnaPlocha_Texturovana_Nevyhladena(int delenie_dlzky,int delenie_uhla)
{
/*
uhol	t0=				smerovy vektor	t1=				smerovy vektor	t2=
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

0		bod0[0][]	->	norm0[0][]		bod1[0][]	->	norm1[0][]		bod2[0][]
1		bod0[1][]	->	norm0[1][]		bod1[1][]	->	norm1[1][]		bod2[1][]
2		bod0[2][]	->	norm0[2][]		bod1[2][]	->	norm1[2][]		bod2[2][]
3		bod0[3][]	->	norm0[3][]		bod1[3][]	->	norm1[3][]		bod2[3][]
4		bod0[4][]	->	norm0[4][]		bod1[4][]	->	norm1[4][]		bod2[4][]
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

najprv	vypocitame vsetky body
potom	napr.: z bodov:				vypocitame normalovy vektor prislusneho stvorca
bod0[0][]				bod1[0][]				bod2[0][]
			norm0[0][]				norm1[0][]
bod0[1][]				bod1[1][]				bod2[1][]
			norm0[1][]				norm1[1][]
bod0[2][]				bod1[2][]				bod2[2][]
			norm0[2][]				norm1[2][]
bod0[3][]				bod1[3][]				bod2[3][]

a potom vypocitame vyhladene normalove vektory pre kazdy bod z pola bodov 0 a 1
norm0[0][]				norm1[0][]
			vnorm1[1][]			--	normalovy vektor pre bod1[1][] 
norm0[1][]				norm1[1][]

normalove vektory pre body bod[x][0][] vypocitame :
							norm0[0][]
				vnorm0[1][]			--	normalovy vektor pre bod0[1][] 
							norm0[1][]
*/

	float	(*bod0)[3];		// smernik na pole vrcholov, pricom vrchol ma 3 suradnice (je pole 3 suradnic)
	float	(*bod1)[3];
	float	(*bod2)[3];
	float	(*text_x);		// smernika na pole vrcholov suradnic suradnic textur
	float	text_y[2];
	float	(*pomocny)[3];
	float	(*norm0)[3];			// normalovy vektor plochy
	float	(*norm1)[3];
	float	a[3],b[3],absolut;
	int		i,j=0;
	float	uhol;
	float	t0,t1,t2;
	float	krivka0[3],krivka1[3],krivka2[3];
	
	bod0  = new float[delenie_uhla][3];
	bod1  = new float[delenie_uhla][3];
	bod2  = new float[delenie_uhla][3];
	norm0 = new float[delenie_uhla][3];
	norm1 = new float[delenie_uhla][3];
	text_x= new float[delenie_uhla];
	
	t0 = ( (float) j / (float) delenie_dlzky );
	RiadiacaKrivka(t0,krivka0);
	text_y[0]=1-t0;
	t1 = ( (float) (j+1) / (float) delenie_dlzky );
	RiadiacaKrivka(t1,krivka1);
	text_y[1]=1-t1;
	t2 = ( (float) (j+2) / (float) delenie_dlzky );
	RiadiacaKrivka(t2,krivka2);

	for(i=0;i<delenie_uhla;i++)
	{
		uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );
		text_x[i]  = 1.0f - (float) i / (float) delenie_uhla;
		
		bod0[i][0] = krivka0[0];
		bod0[i][1] = krivka0[1] * (float) cos( uhol ) - krivka0[2] * (float) sin( uhol );
		bod0[i][2] = krivka0[1] * (float) sin( uhol ) + krivka0[2] * (float) cos( uhol );

		bod1[i][0] = krivka1[0];
		bod1[i][1] = krivka1[1] * (float) cos( uhol ) - krivka1[2] * (float) sin( uhol );
		bod1[i][2] = krivka1[1] * (float) sin( uhol ) + krivka1[2] * (float) cos( uhol );
		
		bod2[i][0] = krivka2[0];
		bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
		bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
	}

	for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
	{
		if(i == (delenie_uhla-1) )
		{
			a[0] = bod1[0][0] - bod1[i][0];				//	+----->
			a[1] = bod1[0][1] - bod1[i][1];				//	 b    |
			a[2] = bod1[0][2] - bod1[i][2];				//	      |
		}												//	    a v
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod1[i][0] - bod0[i][0];
		b[1] = bod1[i][1] - bod0[i][1];
		b[2] = bod1[i][2] - bod0[i][2];
	
		norm0[i][0] = a[1]*b[2] - a[2]*b[1];
		norm0[i][1] = a[2]*b[0] - a[0]*b[2];
		norm0[i][2] = a[0]*b[1] - a[1]*b[0];
						//Optimalization vector
		absolut = (float) sqrt(norm0[i][0]*norm0[i][0]+norm0[i][1]*norm0[i][1]+norm0[i][2]*norm0[i][2]);
		if(absolut>0)		//avoid zero division error
		{
			norm0[i][0] = norm0[i][0]/absolut;
			norm0[i][1] = norm0[i][1]/absolut;
			norm0[i][2] = norm0[i][2]/absolut;
		}
	}

	for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
	{
		if(i == (delenie_uhla-1) )
		{
			a[0] = bod1[0][0] - bod1[i][0];		//	+----->
			a[1] = bod1[0][1] - bod1[i][1];		//	|     b
			a[2] = bod1[0][2] - bod1[i][2];		//	|
		}										//	V a
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod2[i][0] - bod1[i][0];
		b[1] = bod2[i][1] - bod1[i][1];
		b[2] = bod2[i][2] - bod1[i][2];
	
		norm1[i][0] = a[1]*b[2] - a[2]*b[1];
		norm1[i][1] = a[2]*b[0] - a[0]*b[2];
		norm1[i][2] = a[0]*b[1] - a[1]*b[0];
						//Optimalization vector
		absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
		if(absolut>0)		//avoid zero division error
		{
			norm1[i][0] = norm1[i][0]/absolut;
			norm1[i][1] = norm1[i][1]/absolut;
			norm1[i][2] = norm1[i][2]/absolut;
		}
	}

	glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)
	{
		glNormal3fv( norm0[i]  );
		glTexCoord2f( text_x[i+1],text_y[0]);
		glVertex3fv(	bod0[i+1] );
		glTexCoord2f( text_x[i+1],text_y[1]);
		glVertex3fv(	bod1[i+1] );
		glTexCoord2f( text_x[i],text_y[1]);
		glVertex3fv(	bod1[i]   );
		glTexCoord2f( text_x[i],text_y[0]);
		glVertex3fv(	bod0[i]   );
	}
	glNormal3fv( norm0[(delenie_uhla-1)] );
	glTexCoord2f( 0,text_y[0]);
	glVertex3fv(	bod0[0] );
	glTexCoord2f( 0,text_y[1]);
	glVertex3fv(	bod1[0] );
	glTexCoord2f( text_x[delenie_uhla-1],text_y[1]);
	glVertex3fv(	bod1[delenie_uhla-1] );
	glTexCoord2f( text_x[delenie_uhla-1],text_y[0]);
	glVertex3fv(	bod0[delenie_uhla-1] );
	glEnd();
	
	for(j=1;j<(delenie_dlzky-1);j++)
	{
		t0 = ( (float) j / (float) delenie_dlzky );
		text_y[0]=1-t0;
		t1 = ( (float) (j+1) / (float) delenie_dlzky );
		text_y[1]=1-t1;
		t2 = ( (float) (j+2) / (float) delenie_dlzky );
		RiadiacaKrivka(t2,krivka2);
	
		pomocny = bod0;
		bod0 = bod1;		// vymena poli vrcholov
		bod1 = bod2;
		bod2 = pomocny;
		for(i=0;i<delenie_uhla;i++)
		{
			uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );

			bod2[i][0] = krivka2[0];
			bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
			bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
		}
		pomocny = norm0;
		norm0 = norm1;
		norm1 = pomocny;
		for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
		{
			if(i == (delenie_uhla-1) )
			{
				a[0] = bod1[0][0] - bod1[i][0];
				a[1] = bod1[0][1] - bod1[i][1];
				a[2] = bod1[0][2] - bod1[i][2];
			}
			else
			{
				a[0] = bod1[i+1][0] - bod1[i][0];
				a[1] = bod1[i+1][1] - bod1[i][1];
				a[2] = bod1[i+1][2] - bod1[i][2];
			}
	
			b[0] = bod2[i][0] - bod1[i][0];
			b[1] = bod2[i][1] - bod1[i][1];
			b[2] = bod2[i][2] - bod1[i][2];
		
			norm1[i][0] = a[1]*b[2] - a[2]*b[1];
			norm1[i][1] = a[2]*b[0] - a[0]*b[2];
			norm1[i][2] = a[0]*b[1] - a[1]*b[0];
							//Optimalization vector
			absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
			if(absolut>0)		//avoid zero division error
			{
				norm1[i][0] = norm1[i][0]/absolut;
				norm1[i][1] = norm1[i][1]/absolut;
				norm1[i][2] = norm1[i][2]/absolut;
			}
		}

		glBegin(GL_QUADS);
		for(i=0;i<(delenie_uhla-1);i++)
		{
			glNormal3fv(   norm0[i]  );
			glTexCoord2f( text_x[i+1],text_y[0]);
			glVertex3fv(	bod0[i+1] );
			glTexCoord2f( text_x[i+1],text_y[1]);
			glVertex3fv(	bod1[i+1] );
			glTexCoord2f( text_x[i],text_y[1]);
			glVertex3fv(	bod1[i]   );
			glTexCoord2f( text_x[i],text_y[0]);
			glVertex3fv(	bod0[i]   );
		}
		glNormal3fv(   norm0[(delenie_uhla-1)] );
		glTexCoord2f( 0,text_y[0]);
		glVertex3fv(	bod0[0] );
		glTexCoord2f( 0,text_y[1]);
		glVertex3fv(	bod1[0] );
		glTexCoord2f( text_x[delenie_uhla-1],text_y[1]);
		glVertex3fv(	bod1[delenie_uhla-1] );
		glTexCoord2f( text_x[delenie_uhla-1],text_y[0]);
		glVertex3fv(	bod0[delenie_uhla-1] );
		glEnd();
	}

	glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)
	{
		glNormal3fv( norm1[i]  );
		glTexCoord2f( text_x[i+1],text_y[1]);
		glVertex3fv(	bod1[i+1] );
		glTexCoord2f( text_x[i+1],0);
		glVertex3fv(	bod2[i+1] );
		glTexCoord2f( text_x[i],0);
		glVertex3fv(	bod2[i]   );
		glTexCoord2f( text_x[i],text_y[1]);
		glVertex3fv(	bod1[i]   );
	}
	glNormal3fv( norm1[(delenie_uhla-1)] );
	glTexCoord2f( 0,text_y[1]);
	glVertex3fv(	bod1[0] );
	glTexCoord2f( 0,0);
	glVertex3fv(	bod2[0] );
	glTexCoord2f( text_x[delenie_uhla-1],0);
	glVertex3fv(	bod2[delenie_uhla-1] );
	glTexCoord2f( text_x[delenie_uhla-1],text_y[1]);
	glVertex3fv(	bod1[delenie_uhla-1] );
	glEnd();


	delete[] bod0;
	delete[] bod1;
	delete[] bod2;
	delete[] norm0;
	delete[] norm1;
	delete[] text_x;
}


void RotacnaPlocha_Texturovana_bez_svetla(int delenie_dlzky,int delenie_uhla)
{

	float	(*bod0)[3];		// smernik na pole vrcholov, pricom vrchol ma 3 suradnice (je pole 3 suradnic)
	float	(*bod1)[3];
	float	(*text_x);		// smernika na pole vrcholov suradnic suradnic textur
	float	text_y[2];
	float	(*pomocny)[3];
	int		i,j=0;
	float	uhol;
	float	t0,t1;
	float	krivka0[3],krivka1[3];
	
	bod0  = new float[delenie_uhla][3];
	bod1  = new float[delenie_uhla][3];
	text_x= new float[delenie_uhla];
	
	glBegin(GL_QUADS);
	for(j=0;j<delenie_dlzky;j++)
	{
		t0 = ( (float) j / (float) delenie_dlzky );
		text_y[0]=1-t0;
		if(j==0)RiadiacaKrivka(t0,krivka0);
		t1 = ( (float) (j+1) / (float) delenie_dlzky );
		text_y[1]=1-t1;
		RiadiacaKrivka(t1,krivka1);
	
		pomocny = bod0;
		bod0 = bod1;		// vymena poli vrcholov
		bod1 = pomocny;
		for(i=0;i<delenie_uhla;i++)
		{
			uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );
			
			if(j==0)
			{
				text_x[i]  = 1.0f - (float) i / (float) delenie_uhla;
			
				bod0[i][0] = krivka0[0];
				bod0[i][1] = krivka0[1] * (float) cos( uhol ) - krivka0[2] * (float) sin( uhol );
				bod0[i][2] = krivka0[1] * (float) sin( uhol ) + krivka0[2] * (float) cos( uhol );
			}
			bod1[i][0] = krivka1[0];
			bod1[i][1] = krivka1[1] * (float) cos( uhol ) - krivka1[2] * (float) sin( uhol );
			bod1[i][2] = krivka1[1] * (float) sin( uhol ) + krivka1[2] * (float) cos( uhol );
		}

		for(i=0;i<(delenie_uhla-1);i++)
		{
			glTexCoord2f( text_x[i+1],text_y[0]);
			glVertex3fv(	bod0[i+1] );
			glTexCoord2f( text_x[i+1],text_y[1]);
			glVertex3fv(	bod1[i+1] );
			glTexCoord2f( text_x[i],text_y[1]);
			glVertex3fv(	bod1[i]   );
			glTexCoord2f( text_x[i],text_y[0]);
			glVertex3fv(	bod0[i]   );
		}
		glTexCoord2f( 0,text_y[0]);
		glVertex3fv(	bod0[0]  );
		glTexCoord2f( 0,text_y[1]);
		glVertex3fv(	bod1[0]  );
		glTexCoord2f( text_x[delenie_uhla-1],text_y[1]);
		glVertex3fv(	bod1[delenie_uhla-1] );
		glTexCoord2f( text_x[delenie_uhla-1],text_y[0]);
		glVertex3fv(	bod0[delenie_uhla-1] );
	}
	glEnd();

	delete[] bod0;
	delete[] bod1;
	delete[] text_x;
}

void RotacnaPlocha_Nevyhladena(int delenie_dlzky,int delenie_uhla)
{
/*
uhol	t0=				smerovy vektor	t1=				smerovy vektor	t2=
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

0		bod0[0][]	->	norm0[0][]		bod1[0][]	->	norm1[0][]		bod2[0][]
1		bod0[1][]	->	norm0[1][]		bod1[1][]	->	norm1[1][]		bod2[1][]
2		bod0[2][]	->	norm0[2][]		bod1[2][]	->	norm1[2][]		bod2[2][]
3		bod0[3][]	->	norm0[3][]		bod1[3][]	->	norm1[3][]		bod2[3][]
4		bod0[4][]	->	norm0[4][]		bod1[4][]	->	norm1[4][]		bod2[4][]
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

najprv	vypocitame vsetky body
potom	napr.: z bodov:				vypocitame normalovy vektor prislusneho stvorca
bod0[0][]				bod1[0][]				bod2[0][]
			norm0[0][]				norm1[0][]
bod0[1][]				bod1[1][]				bod2[1][]
			norm0[1][]				norm1[1][]
bod0[2][]				bod1[2][]				bod2[2][]
			norm0[2][]				norm1[2][]
bod0[3][]				bod1[3][]				bod2[3][]

a potom vypocitame vyhladene normalove vektory pre kazdy bod z pola bodov 0 a 1
norm0[0][]				norm1[0][]
			vnorm1[1][]			--	normalovy vektor pre bod1[1][] 
norm0[1][]				norm1[1][]

normalove vektory pre body bod[x][0][] vypocitame :
							norm0[0][]
				vnorm0[1][]			--	normalovy vektor pre bod0[1][] 
							norm0[1][]
*/

	float	(*bod0)[3];		// smernik na pole vrcholov, pricom vrchol ma 3 suradnice (je pole 3 suradnic)
	float	(*bod1)[3];
	float	(*bod2)[3];
	float	(*pomocny)[3];
	float	(*norm0)[3];			// normalovy vektor plochy
	float	(*norm1)[3];
	//float	(*vnorm0)[3];			// vyhladeny normalovy vektor plochy
	//float	(*vnorm1)[3];
	float	a[3],b[3],absolut;
	int		i,j=0;
	float	uhol;
	float	t0,t1,t2;
	float	krivka0[3],krivka1[3],krivka2[3];
	
	bod0  = new float[delenie_uhla][3];
	bod1  = new float[delenie_uhla][3];
	bod2  = new float[delenie_uhla][3];
	norm0 = new float[delenie_uhla][3];
	norm1 = new float[delenie_uhla][3];
	
	t0 = ( (float) j / (float) delenie_dlzky );
	RiadiacaKrivka(t0,krivka0);
	t1 = ( (float) (j+1) / (float) delenie_dlzky );
	RiadiacaKrivka(t1,krivka1);
	t2 = ( (float) (j+2) / (float) delenie_dlzky );
	RiadiacaKrivka(t2,krivka2);

	for(i=0;i<delenie_uhla;i++)
	{
		uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );

		bod0[i][0] = krivka0[0];
		bod0[i][1] = krivka0[1] * (float) cos( uhol ) - krivka0[2] * (float) sin( uhol );
		bod0[i][2] = krivka0[1] * (float) sin( uhol ) + krivka0[2] * (float) cos( uhol );

		bod1[i][0] = krivka1[0];
		bod1[i][1] = krivka1[1] * (float) cos( uhol ) - krivka1[2] * (float) sin( uhol );
		bod1[i][2] = krivka1[1] * (float) sin( uhol ) + krivka1[2] * (float) cos( uhol );
		
		bod2[i][0] = krivka2[0];
		bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
		bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
	}

	for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
	{
		if(i == (delenie_uhla-1) )
		{
			a[0] = bod1[0][0] - bod1[i][0];				//	+----->
			a[1] = bod1[0][1] - bod1[i][1];				//	 b    |
			a[2] = bod1[0][2] - bod1[i][2];				//	      |
		}												//	    a v
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod1[i][0] - bod0[i][0];
		b[1] = bod1[i][1] - bod0[i][1];
		b[2] = bod1[i][2] - bod0[i][2];
	
		norm0[i][0] = a[1]*b[2] - a[2]*b[1];
		norm0[i][1] = a[2]*b[0] - a[0]*b[2];
		norm0[i][2] = a[0]*b[1] - a[1]*b[0];
						//Optimalization vector
		absolut = (float) sqrt(norm0[i][0]*norm0[i][0]+norm0[i][1]*norm0[i][1]+norm0[i][2]*norm0[i][2]);
		if(absolut>0)		//avoid zero division error
		{
			norm0[i][0] = norm0[i][0]/absolut;
			norm0[i][1] = norm0[i][1]/absolut;
			norm0[i][2] = norm0[i][2]/absolut;
		}
	}

	for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
	{
		if(i == (delenie_uhla-1) )
		{
			a[0] = bod1[0][0] - bod1[i][0];		//	+----->
			a[1] = bod1[0][1] - bod1[i][1];		//	|     b
			a[2] = bod1[0][2] - bod1[i][2];		//	|
		}										//	V a
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod2[i][0] - bod1[i][0];
		b[1] = bod2[i][1] - bod1[i][1];
		b[2] = bod2[i][2] - bod1[i][2];
	
		norm1[i][0] = a[1]*b[2] - a[2]*b[1];
		norm1[i][1] = a[2]*b[0] - a[0]*b[2];
		norm1[i][2] = a[0]*b[1] - a[1]*b[0];
						//Optimalization vector
		absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
		if(absolut>0)		//avoid zero division error
		{
			norm1[i][0] = norm1[i][0]/absolut;
			norm1[i][1] = norm1[i][1]/absolut;
			norm1[i][2] = norm1[i][2]/absolut;
		}
	}

	glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)
	{
		glNormal3fv( norm0[i]  );
		glVertex3fv( bod0[i+1] );
		glVertex3fv( bod1[i+1] );
		glVertex3fv( bod1[i]   );
		glVertex3fv( bod0[i]   );
	}
	glNormal3fv( norm0[(delenie_uhla-1)] );
	glVertex3fv( bod0[0] );
	glVertex3fv( bod1[0] );
	glVertex3fv( bod1[(delenie_uhla-1)] );
	glVertex3fv( bod0[(delenie_uhla-1)] );
	glEnd();
	
	for(j=1;j<(delenie_dlzky-1);j++)
	{
		t2 = ( (float) (j+2) / (float) delenie_dlzky );
		RiadiacaKrivka(t2,krivka2);
	
		pomocny = bod0;
		bod0 = bod1;		// vymena poli vrcholov
		bod1 = bod2;
		bod2 = pomocny;
		for(i=0;i<delenie_uhla;i++)
		{
			uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );

			bod2[i][0] = krivka2[0];
			bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
			bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
		}
		pomocny = norm0;
		norm0 = norm1;
		norm1 = pomocny;
		for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
		{
			if(i == (delenie_uhla-1) )
			{
				a[0] = bod1[0][0] - bod1[i][0];
				a[1] = bod1[0][1] - bod1[i][1];
				a[2] = bod1[0][2] - bod1[i][2];
			}
			else
			{
				a[0] = bod1[i+1][0] - bod1[i][0];
				a[1] = bod1[i+1][1] - bod1[i][1];
				a[2] = bod1[i+1][2] - bod1[i][2];
			}
	
			b[0] = bod2[i][0] - bod1[i][0];
			b[1] = bod2[i][1] - bod1[i][1];
			b[2] = bod2[i][2] - bod1[i][2];
		
			norm1[i][0] = a[1]*b[2] - a[2]*b[1];
			norm1[i][1] = a[2]*b[0] - a[0]*b[2];
			norm1[i][2] = a[0]*b[1] - a[1]*b[0];
							//Optimalization vector
			absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
			if(absolut>0)		//avoid zero division error
			{
				norm1[i][0] = norm1[i][0]/absolut;
				norm1[i][1] = norm1[i][1]/absolut;
				norm1[i][2] = norm1[i][2]/absolut;
			}
		}

		glBegin(GL_QUADS);
		for(i=0;i<(delenie_uhla-1);i++)
		{
			glNormal3fv( norm0[i]  );
			glVertex3fv( bod0[i+1] );
			glVertex3fv( bod1[i+1] );
			glVertex3fv( bod1[i]   );
			glVertex3fv( bod0[i]   );
		}
		glNormal3fv( norm0[(delenie_uhla-1)] );
		glVertex3fv( bod0[0] );
		glVertex3fv( bod1[0] );
		glVertex3fv( bod1[(delenie_uhla-1)] );
		glVertex3fv( bod0[(delenie_uhla-1)] );
		glEnd();
	}

	glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)
	{
		glNormal3fv( norm1[i]  );
		glVertex3fv( bod1[i+1] );
		glVertex3fv( bod2[i+1] );
		glVertex3fv( bod2[i]   );
		glVertex3fv( bod1[i]   );
	}
	glNormal3fv( norm1[(delenie_uhla-1)] );
	glVertex3fv( bod1[0] );
	glVertex3fv( bod2[0] );
	glVertex3fv( bod2[(delenie_uhla-1)] );
	glVertex3fv( bod1[(delenie_uhla-1)] );
	glEnd();


	delete[] bod0;
	delete[] bod1;
	delete[] bod2;
	delete[] norm0;
	delete[] norm1;
}


void RotacnaPlocha_Netexturovana_bez_svetla(int delenie_dlzky,int delenie_uhla)
{

	float	(*bod0)[3];		// smernik na pole vrcholov, pricom vrchol ma 3 suradnice (je pole 3 suradnic)
	float	(*bod1)[3];
	float	(*pomocny)[3];
	int		i,j=0;
	float	uhol;
	float	t0,t1;
	float	krivka0[3],krivka1[3];
	
	bod0  = new float[delenie_uhla][3];
	bod1  = new float[delenie_uhla][3];
	
	glBegin(GL_QUADS);
	for(j=0;j<delenie_dlzky;j++)
	{
		t0 = ( (float) j / (float) delenie_dlzky );
		if(j==0)RiadiacaKrivka(t0,krivka0);
		t1 = ( (float) (j+1) / (float) delenie_dlzky );
		RiadiacaKrivka(t1,krivka1);
	
		pomocny = bod0;
		bod0 = bod1;		// vymena poli vrcholov
		bod1 = pomocny;
		for(i=0;i<delenie_uhla;i++)
		{
			uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );
			
			if(j==0)
			{
				bod0[i][0] = krivka0[0];
				bod0[i][1] = krivka0[1] * (float) cos( uhol ) - krivka0[2] * (float) sin( uhol );
				bod0[i][2] = krivka0[1] * (float) sin( uhol ) + krivka0[2] * (float) cos( uhol );
			}
			bod1[i][0] = krivka1[0];
			bod1[i][1] = krivka1[1] * (float) cos( uhol ) - krivka1[2] * (float) sin( uhol );
			bod1[i][2] = krivka1[1] * (float) sin( uhol ) + krivka1[2] * (float) cos( uhol );
		}

		for(i=0;i<(delenie_uhla-1);i++)
		{
			glVertex3fv(	bod0[i+1] );
			glVertex3fv(	bod1[i+1] );
			glVertex3fv(	bod1[i]   );
			glVertex3fv(	bod0[i]   );
		}
		glVertex3fv(	bod0[0]  );
		glVertex3fv(	bod1[0]  );
		glVertex3fv(	bod1[delenie_uhla-1] );
		glVertex3fv(	bod0[delenie_uhla-1] );
	}
	glEnd();

	delete[] bod0;
	delete[] bod1;
}